"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.mintNewEditionFromMasterEditionViaToken = exports.getMintNewEditionFromMasterEditionViaTokenInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getMintNewEditionFromMasterEditionViaTokenInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        [
            'mintNewEditionFromMasterEditionViaTokenArgs',
            (0, types_1.getMintNewEditionFromMasterEditionViaTokenArgsSerializer)(context),
        ],
    ], { description: 'MintNewEditionFromMasterEditionViaTokenInstructionData' }), (value) => ({
        ...value,
        discriminator: 11,
    }));
}
exports.getMintNewEditionFromMasterEditionViaTokenInstructionDataSerializer = getMintNewEditionFromMasterEditionViaTokenInstructionDataSerializer;
// Instruction.
function mintNewEditionFromMasterEditionViaToken(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    // Resolved accounts.
    const newMetadataAccount = input.newMetadata;
    const newEditionAccount = input.newEdition;
    const masterEditionAccount = input.masterEdition;
    const newMintAccount = input.newMint;
    const editionMarkPdaAccount = input.editionMarkPda;
    const newMintAuthorityAccount = input.newMintAuthority;
    const payerAccount = input.payer ?? context.payer;
    const tokenAccountOwnerAccount = input.tokenAccountOwner;
    const tokenAccountAccount = input.tokenAccount;
    const newMetadataUpdateAuthorityAccount = input.newMetadataUpdateAuthority;
    const metadataAccount = input.metadata;
    const tokenProgramAccount = input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    };
    const systemProgramAccount = input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    };
    const rentAccount = input.rent;
    // New Metadata.
    keys.push({
        pubkey: newMetadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMetadataAccount, true),
    });
    // New Edition.
    keys.push({
        pubkey: newEditionAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newEditionAccount, true),
    });
    // Master Edition.
    keys.push({
        pubkey: masterEditionAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(masterEditionAccount, true),
    });
    // New Mint.
    keys.push({
        pubkey: newMintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMintAccount, true),
    });
    // Edition Mark Pda.
    keys.push({
        pubkey: editionMarkPdaAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(editionMarkPdaAccount, true),
    });
    // New Mint Authority.
    signers.push(newMintAuthorityAccount);
    keys.push({
        pubkey: newMintAuthorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMintAuthorityAccount, false),
    });
    // Payer.
    signers.push(payerAccount);
    keys.push({
        pubkey: payerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(payerAccount, true),
    });
    // Token Account Owner.
    signers.push(tokenAccountOwnerAccount);
    keys.push({
        pubkey: tokenAccountOwnerAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenAccountOwnerAccount, false),
    });
    // Token Account.
    keys.push({
        pubkey: tokenAccountAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenAccountAccount, false),
    });
    // New Metadata Update Authority.
    keys.push({
        pubkey: newMetadataUpdateAuthorityAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(newMetadataUpdateAuthorityAccount, false),
    });
    // Metadata.
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, false),
    });
    // Token Program.
    keys.push({
        pubkey: tokenProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(tokenProgramAccount, false),
    });
    // System Program.
    keys.push({
        pubkey: systemProgramAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(systemProgramAccount, false),
    });
    // Rent (optional).
    if (rentAccount) {
        keys.push({
            pubkey: rentAccount,
            isSigner: false,
            isWritable: (0, umi_1.checkForIsWritableOverride)(rentAccount, false),
        });
    }
    // Data.
    const data = getMintNewEditionFromMasterEditionViaTokenInstructionDataSerializer(context).serialize(input);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.mintNewEditionFromMasterEditionViaToken = mintNewEditionFromMasterEditionViaToken;
//# sourceMappingURL=mintNewEditionFromMasterEditionViaToken.js.map