"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.revokeCollectionAuthority = exports.getRevokeCollectionAuthorityInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
function getRevokeCollectionAuthorityInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], { description: 'RevokeCollectionAuthorityInstructionData' }), (value) => ({
        ...value,
        discriminator: 24,
    }));
}
exports.getRevokeCollectionAuthorityInstructionDataSerializer = getRevokeCollectionAuthorityInstructionDataSerializer;
// Instruction.
function revokeCollectionAuthority(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    // Resolved accounts.
    const collectionAuthorityRecordAccount = input.collectionAuthorityRecord;
    const delegateAuthorityAccount = input.delegateAuthority;
    const revokeAuthorityAccount = input.revokeAuthority;
    const mintAccount = input.mint;
    const metadataAccount = input.metadata ??
        (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(mintAccount) });
    // Collection Authority Record.
    keys.push({
        pubkey: collectionAuthorityRecordAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(collectionAuthorityRecordAccount, true),
    });
    // Delegate Authority.
    keys.push({
        pubkey: delegateAuthorityAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(delegateAuthorityAccount, true),
    });
    // Revoke Authority.
    signers.push(revokeAuthorityAccount);
    keys.push({
        pubkey: revokeAuthorityAccount.publicKey,
        isSigner: true,
        isWritable: (0, umi_1.checkForIsWritableOverride)(revokeAuthorityAccount, true),
    });
    // Metadata.
    keys.push({
        pubkey: metadataAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(metadataAccount, false),
    });
    // Mint.
    keys.push({
        pubkey: mintAccount,
        isSigner: false,
        isWritable: (0, umi_1.checkForIsWritableOverride)(mintAccount, false),
    });
    // Data.
    const data = getRevokeCollectionAuthorityInstructionDataSerializer(context).serialize({});
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.revokeCollectionAuthority = revokeCollectionAuthority;
//# sourceMappingURL=revokeCollectionAuthority.js.map