import { Option, TransactionBuilder } from '@metaplex-foundation/umi';
import { Creator, TokenStandard } from '../generated';
import { createV1 as baseCreateV1, CreateV1InstructionAccounts, CreateV1InstructionData, CreateV1InstructionDataArgs, getCreateV1InstructionDataSerializer } from '../generated/instructions/createV1';
export { CreateV1InstructionAccounts, CreateV1InstructionData, CreateV1InstructionDataArgs, getCreateV1InstructionDataSerializer, };
export type CreateV1InstructionInput = Omit<Parameters<typeof baseCreateV1>[1], 'tokenStandard' | 'creators'> & {
    /** @defaultValue `false` */
    isCollection?: boolean;
    /** @defaultValue `TokenStandard.NonFungible` */
    tokenStandard?: TokenStandard;
    /** @defaultValue Defaults to using the update authority as the only creator with 100% shares. */
    creators?: Option<Array<Creator>>;
};
export declare const createV1: (context: Parameters<typeof baseCreateV1>[0], input: CreateV1InstructionInput) => TransactionBuilder;
